## osm2pgsql 1.8.0%2Bds

=== docs/CMakeLists.txt ===
message(STATUS "Looking for pandoc")
find_program(PANDOC pandoc)
message(STATUS "Looking for argparse-manpage")
find_program(ARGPARSE_MANPAGE argparse-manpage)

set(MANPAGE_TARGETS "")

if(PANDOC)
    message(STATUS "Looking for pandoc - found")
    message(STATUS "  osm2pgsql manual page can be built using 'man' target")
    set(PANDOC_MAN_OPTIONS
        -s
        -t man
        --template ${CMAKE_CURRENT_SOURCE_DIR}/manpage.template
        --variable "version=${PROJECT_VERSION}"
        --variable "title=OSM2PGSQL"
        --variable "section=1"
    )

    add_custom_command(OUTPUT osm2pgsql.1
        COMMAND ${PANDOC} ${PANDOC_MAN_OPTIONS} -o osm2pgsql.1
            ${CMAKE_CURRENT_SOURCE_DIR}/osm2pgsql.md
        DEPENDS osm2pgsql.md manpage.template
        COMMENT "Building manpage osm2pgsql.1"
        VERBATIM)

    list(APPEND MANPAGE_TARGETS osm2pgsql.1)
else()
    message(STATUS "Looking for pandoc - not found")
    message(STATUS "  osm2pgsql manual page can not be built")
endif()

if(ARGPARSE_MANPAGE)
    message(STATUS "Looking for argparse-manpage - found")
    message(STATUS "  osm2pgsql-replication manual page can be built using 'man' target")

    add_custom_command(OUTPUT osm2pgsql-replication.1
        COMMAND python3 ${CMAKE_CURRENT_SOURCE_DIR}/manpage_from_python.py --version ${PROJECT_VERSION} --description "osm2pgsql database updater" ${CMAKE_SOURCE_DIR}/scripts/osm2pgsql-replication > ${CMAKE_CURRENT_BINARY_DIR}/osm2pgsql-replication.1
        DEPENDS ${CMAKE_SOURCE_DIR}/scripts/osm2pgsql-replication manpage_from_python.py
        COMMENT "Building manpage osm2pgsql-replication.1"
        VERBATIM)

    list(APPEND MANPAGE_TARGETS osm2pgsql-replication.1)
else()
    message(STATUS "Looking for argparse-manpage - not found")
    message(STATUS "  osm2pgsql-replication page can not be built")
endif()

if(MANPAGE_TARGETS)
    add_custom_target(man DEPENDS ${MANPAGE_TARGETS} VERBATIM)
endif()

if(ENABLE_INSTALL)
    install(FILES osm2pgsql.1 DESTINATION share/man/man1)
    install(FILES osm2pgsql-replication.1 DESTINATION share/man/man1)
endif()

=== src/CMakeLists.txt ===

add_library(osm2pgsql_lib STATIC)

target_sources(osm2pgsql_lib PRIVATE
  db-copy.cpp
  dependency-manager.cpp
  expire-tiles.cpp
  gazetteer-style.cpp
  geom.cpp
  geom-box.cpp
  geom-from-osm.cpp
  geom-functions.cpp
  geom-pole-of-inaccessibility.cpp
  input.cpp
  logging.cpp
  middle.cpp
  middle-pgsql.cpp
  middle-ram.cpp
  node-locations.cpp
  node-persistent-cache.cpp
  options.cpp
  ordered-index.cpp
  osmdata.cpp
  output-gazetteer.cpp
  output-null.cpp
  output-pgsql.cpp
  output.cpp
  pgsql.cpp
  pgsql-capabilities.cpp
  pgsql-helper.cpp
  progress-display.cpp
  reprojection.cpp
  table.cpp
  taginfo.cpp
  tagtransform-c.cpp
  tagtransform.cpp
  tile.cpp
  thread-pool.cpp
  util.cpp
  wildcmp.cpp
  wkb.cpp
)

if (WITH_LUA)
    set_property(DIRECTORY APPEND PROPERTY CMAKE_CONFIGURE_DEPENDS
                 "${CMAKE_CURRENT_SOURCE_DIR}/init.lua")
    file(READ "${CMAKE_CURRENT_SOURCE_DIR}/init.lua" LUA_INIT_CODE)
    configure_file(lua-init.cpp.in lua-init.cpp @ONLY)
    target_sources(osm2pgsql_lib PRIVATE
        flex-index.cpp
        flex-table.cpp
        flex-table-column.cpp
        flex-lua-geom.cpp
        flex-lua-index.cpp
        flex-write.cpp
        geom-transform.cpp
        lua-utils.cpp
        output-flex.cpp
        tagtransform-lua.cpp
        ${CMAKE_CURRENT_BINARY_DIR}/lua-init.cpp)
endif()

target_sources(osm2pgsql_lib PRIVATE ${PROJECT_BINARY_DIR}/src/version.cpp)

if (HAVE_PROJ4)
    target_sources(osm2pgsql_lib PRIVATE reprojection-generic-proj4.cpp)
    if (NOT MSVC)
        set_source_files_properties(reprojection-generic-proj4.cpp
            PROPERTIES COMPILE_FLAGS -Wno-deprecated-declarations)
    endif()
elseif(HAVE_PROJ6)
    target_sources(osm2pgsql_lib PRIVATE reprojection-generic-proj6.cpp)
else()
    target_sources(osm2pgsql_lib PRIVATE reprojection-generic-none.cpp)
endif()

set_target_properties(osm2pgsql_lib PROPERTIES OUTPUT_NAME osm2pgsql)
target_link_libraries(osm2pgsql_lib ${LIBS})

## osm2pgsql 1.8.0+ds

=== CMakeLists.txt ===

cmake_minimum_required(VERSION 3.5.0)

project(osm2pgsql VERSION 1.8.0 LANGUAGES CXX C)

set(CMAKE_EXPORT_COMPILE_COMMANDS ON)

list(APPEND CMAKE_MODULE_PATH "${CMAKE_CURRENT_SOURCE_DIR}/cmake")

# Do not create install targets when run as a subproject.
# Currently used by Nominatim which cannot yet rely on installed versions
# of osm2pgsql.
if (${PROJECT_NAME} STREQUAL ${CMAKE_PROJECT_NAME})
    set(ENABLE_INSTALL ON)
else()
    set(ENABLE_INSTALL OFF)
endif()

if (WIN32)
    set(DEFAULT_STYLE "default.style" CACHE STRING "Default style used unless one is given on the command line")
else()
    set(DEFAULT_STYLE "${CMAKE_INSTALL_PREFIX}/share/osm2pgsql/default.style" CACHE STRING "Default style used unless one is given on the command line")
endif()

option(BUILD_TESTS    "Build test suite" OFF)
option(BUILD_COVERAGE "Build with coverage" OFF)
option(WITH_LUA       "Build with Lua support" ON)
option(WITH_LUAJIT    "Build with LuaJIT support" OFF)

if (PROJECT_SOURCE_DIR STREQUAL PROJECT_BINARY_DIR)
    message(FATAL_ERROR "In-source builds are not allowed, please use a separate build directory like `mkdir build && cd build && cmake ..`")
endif()

message(STATUS "Building osm2pgsql ${PROJECT_VERSION}")

if (NOT CMAKE_BUILD_TYPE)
    set(CMAKE_BUILD_TYPE RelWithDebInfo)
endif()

if (NOT "${CMAKE_CXX_STANDARD}")
    set(CMAKE_CXX_STANDARD 17)
endif()
message(STATUS "Building in C++${CMAKE_CXX_STANDARD} mode")
set(CMAKE_CXX_EXTENSIONS OFF)
set(CMAKE_CXX_STANDARD_REQUIRED ON)

if (MSVC)
    add_definitions(-D_CRT_SECURE_NO_WARNINGS -DNOMINMAX)
    add_compile_options(-wd4996)
    set(CMAKE_EXE_LINKER_FLAGS "${CMAKE_EXE_LINKER_FLAGS} /ignore:4099 /STACK:30000000")
else()
    add_compile_options(-Wall)
endif()

option(EXTERNAL_LIBOSMIUM "Do not use the bundled libosmium" OFF)
option(EXTERNAL_PROTOZERO "Do not use the bundled protozero" OFF)
option(EXTERNAL_FMT       "Do not use the bundled fmt"       OFF)

set(USE_PROJ_LIB "auto" CACHE STRING "Which version of PROJ API to use: ('4', '6', 'off', or 'auto')")

if (NOT WIN32 AND NOT APPLE)
    # No need for this path, just a workaround to make cmake work on all systems.
    # Without this we need the PostgreSQL server libraries installed.
    # https://stackoverflow.com/questions/13920383/findpostgresql-cmake-wont-work-on-ubuntu
    set(PostgreSQL_TYPE_INCLUDE_DIR /usr/include)
endif()

set(MINIMUM_POSTGRESQL_SERVER_VERSION "9.6")
set(MINIMUM_POSTGRESQL_SERVER_VERSION_NUM "90600")

set(PostgreSQL_ADDITIONAL_VERSIONS "15" "14" "13" "12" "11" "10" "9.6")

#############################################################
# Version
#############################################################

find_package(Git)

if (GIT_FOUND)
    execute_process(COMMAND "${GIT_EXECUTABLE}" describe --tags --dirty=-changed
                    WORKING_DIRECTORY "${PROJECT_SOURCE_DIR}"
                    OUTPUT_VARIABLE VERSION_FROM_GIT
                    ERROR_QUIET OUTPUT_STRIP_TRAILING_WHITESPACE)
    if (VERSION_FROM_GIT)
        set(VERSION_FROM_GIT " (${VERSION_FROM_GIT})")
    endif()
endif()

configure_file(
    ${PROJECT_SOURCE_DIR}/src/version.cpp.in
    ${PROJECT_BINARY_DIR}/src/version.cpp
)

#############################################################
# Coverage
#############################################################

if (BUILD_COVERAGE)
    if (NOT BUILD_TESTS)
        message(WARNING "Coverage build enabled, but tests not enabled!")
    endif()

    if (CMAKE_CXX_COMPILER_ID STREQUAL "Clang")
        string(REGEX REPLACE "^([0-9]+).*$" "llvm-cov-\\1"
               gcov_ ${CMAKE_CXX_COMPILER_VERSION})
        set(gcov_param_ " gcov")
    else()
        set(gcov_ "gcov")
        set(gcov_param_ "")
    endif()

    message(STATUS "Looking for coverage tool: ${gcov_}")

    find_program(GCOV ${gcov_} DOC "Coverage tool")

    if (GCOV STREQUAL "GCOV-NOTFOUND")
        message(STATUS "  coverage tool not found - coverage disabled")
    else()
        message(STATUS "  found")

        message(STATUS "Looking von gcovr")
        find_program(GCOVR "gcovr" DOC "Coverage report tool")
        if (GCOVR STREQUAL "GCOVR-NOTFOUND")
            message(WARNING "  gcovr not found - coverage will not work")
        else()
            message(STATUS "  found")
        endif()

        add_compile_options(-g -O0 -fno-inline-functions -fno-inline --coverage)

        set(CMAKE_EXE_LINKER_FLAGS "${CMAKE_EXE_LINKER_FLAGS} --coverage"
            CACHE
            STRING "Flags used by the linker during all build types."
            FORCE)

        set(coverage_report_dir "${CMAKE_BINARY_DIR}/coverage")
        file(MAKE_DIRECTORY ${coverage_report_dir})
        add_custom_target(coverage
            ${GCOVR}
            ${CMAKE_BINARY_DIR}
            --root=${CMAKE_SOURCE_DIR}
            --html-details
            --html-title "osm2pgsql coverage report"
            #--verbose
            #--keep
            --delete
            '--exclude=.*contrib.*'
            --sort-percentage
            --gcov-executable=${GCOV}${gcov_param_}
            --output=${coverage_report_dir}/index.html)
    endif()
endif()

#############################################################
# Detect available headers and set global compiler options
#############################################################

include(CheckIncludeFiles)

add_definitions(-DDEFAULT_STYLE=\"${DEFAULT_STYLE}\")

#############################################################
# Find necessary libraries
#############################################################

if (NOT EXTERNAL_LIBOSMIUM)
    set(OSMIUM_INCLUDE_DIR "${CMAKE_CURRENT_SOURCE_DIR}/contrib/libosmium/include")
endif()

if (NOT EXTERNAL_PROTOZERO)
    set(PROTOZERO_INCLUDE_DIR "${CMAKE_CURRENT_SOURCE_DIR}/contrib/protozero/include")
endif()

if (NOT EXTERNAL_FMT)
    set(FMT_INCLUDE_DIR "${CMAKE_CURRENT_SOURCE_DIR}/contrib/fmt/include")
endif()

include_directories(${CMAKE_CURRENT_SOURCE_DIR}/src ${CMAKE_CURRENT_BINARY_DIR})

find_package(Osmium 2.17.3 REQUIRED COMPONENTS io)
include_directories(SYSTEM ${OSMIUM_INCLUDE_DIRS} ${PROTOZERO_INCLUDE_DIR} ${FMT_INCLUDE_DIR})

if (WITH_LUA)
    if (WITH_LUAJIT)
        message(STATUS "Building with LuaJIT support")
        find_package(LuaJIT REQUIRED)
        include_directories(SYSTEM ${LUAJIT_INCLUDE_DIR})
        add_definitions(-DHAVE_LUAJIT=1)
    else()
        message(STATUS "Building with Lua support")
        find_package(Lua REQUIRED)
        include_directories(SYSTEM ${LUA_INCLUDE_DIR})
    endif()
    add_definitions(-DHAVE_LUA=1)
    find_program(LUA_EXE NAMES lua lua5.4 lua5.3 lua5.2 lua5.1)
else()
    message(STATUS "Building without Lua support")
endif()

find_package(Boost 1.50 REQUIRED COMPONENTS system filesystem)
include_directories(SYSTEM ${Boost_INCLUDE_DIR})

find_package(PostgreSQL REQUIRED)
include_directories(SYSTEM ${PostgreSQL_INCLUDE_DIRS})

find_package(Threads)

############### Libraries are found now ########################

set(LIBS ${Boost_LIBRARIES} ${PostgreSQL_LIBRARY} ${OSMIUM_LIBRARIES})

if (USE_PROJ_LIB STREQUAL "off")
    message(STATUS "Proj library disabled (because USE_PROJ_LIB is set to 'off').")
else()
    find_path(PROJ4_INCLUDE_DIR proj_api.h)
    if (PROJ4_INCLUDE_DIR AND NOT USE_PROJ_LIB STREQUAL "6")
        message(STATUS "Found proj_api.h")
        find_library(PROJ_LIBRARY NAMES proj)
        message(STATUS "Found Proj [API 4] ${PROJ_LIBRARY}")
        add_definitions(-DHAVE_GENERIC_PROJ=4)
        set(HAVE_PROJ4 1)
        list(APPEND LIBS ${PROJ_LIBRARY})
        include_directories(SYSTEM ${PROJ4_INCLUDE_DIR})
    elseif (NOT USE_PROJ_LIB STREQUAL "4")
        find_path(PROJ6_INCLUDE_DIR proj.h)
        find_library(PROJ_LIBRARY NAMES proj)
        if (PROJ_LIBRARY)
            message(STATUS "Found Proj [API 6] ${PROJ_LIBRARY}")
            add_definitions(-DHAVE_GENERIC_PROJ=6)
            set(HAVE_PROJ6 1)
            list(APPEND LIBS ${PROJ_LIBRARY})
            include_directories(SYSTEM ${PROJ6_INCLUDE_DIR})
        else()
            message(STATUS "Proj library not found.")
            message(STATUS "    Only Mercartor and WGS84 projections will be available.")
        endif()
    endif()
endif()

if (USE_PROJ_LIB STREQUAL "4" AND NOT HAVE_PROJ4)
    message(FATAL_ERROR "USE_PROJ_LIB was set to '4', but PROJ version 4 API not found")
endif()

if (USE_PROJ_LIB STREQUAL "6" AND NOT HAVE_PROJ6)
    message(FATAL_ERROR "USE_PROJ_LIB was set to '6', but PROJ version 6 API not found")
endif()

if (LUAJIT_FOUND)
    list(APPEND LIBS ${LUAJIT_LIBRARIES})
elseif (LUA_FOUND)
    list(APPEND LIBS ${LUA_LIBRARIES})
endif()

if (WIN32)
    list(APPEND LIBS ws2_32)
    if (MSVC)
        find_path(GETOPT_INCLUDE_DIR getopt.h)
        find_library(GETOPT_LIBRARY NAMES wingetopt getopt)
        if (GETOPT_INCLUDE_DIR AND GETOPT_LIBRARY)
            include_directories(SYSTEM ${GETOPT_INCLUDE_DIR})
            list(APPEND LIBS ${GETOPT_LIBRARY})
        else()
            message(FATAL_ERROR "Can not find getopt library for Windows. Please get it from https://github.com/alex85k/wingetopt or alternative source.")
        endif()
    endif()
endif()

message(STATUS "Libraries used to build: ${LIBS}")

#############################################################
# Build the library and executable file
#############################################################

add_subdirectory(src)

add_executable(osm2pgsql src/osm2pgsql.cpp)
target_link_libraries(osm2pgsql osm2pgsql_lib ${LIBS})

#############################################################
# Optional "clang-tidy" target
#############################################################

message(STATUS "Looking for clang-tidy")
find_program(CLANG_TIDY
             NAMES clang-tidy clang-tidy-16 clang-tidy-15 clang-tidy-14 clang-tidy-13 clang-tidy-12 clang-tidy-11)

if (CLANG_TIDY)
    message(STATUS "Looking for clang-tidy - found ${CLANG_TIDY}")

    file(GLOB CT_CHECK_FILES src/*.cpp tests/*cpp)

    add_custom_target(clang-tidy
        ${CLANG_TIDY}
        -p ${CMAKE_BINARY_DIR}
        ${CT_CHECK_FILES}
    )
else()
    message(STATUS "Looking for clang-tidy - not found")
    message(STATUS "  Build target 'clang-tidy' will not be available.")
endif()

#############################################################
# Build tests
#############################################################

if (BUILD_TESTS)
    enable_testing()
    if (NOT TESTING_TIMEOUT)
        set(TESTING_TIMEOUT 1200)
    endif()
    add_subdirectory(tests)
    configure_file(
        ${PROJECT_SOURCE_DIR}/tests/run-behave.in
        ${PROJECT_BINARY_DIR}/run-behave
    )
else()
    message(STATUS "Tests disabled. Set BUILD_TESTS=ON to enable tests.")
endif()

#############################################################
# Man page
#############################################################

add_subdirectory(docs)

#############################################################
# Install
#############################################################

include(GNUInstallDirs)

if (ENABLE_INSTALL)
    install(TARGETS osm2pgsql DESTINATION bin)
    install(FILES default.style empty.style DESTINATION share/osm2pgsql)
    install(PROGRAMS scripts/osm2pgsql-replication DESTINATION bin)
endif()

=== tests/CMakeLists.txt ===
# Add a new test
#
# set_test(name [LABELS labels])
#
# name - Name of test (source file without suffix)
# labels - optional labels for the test
function(set_test test_name)
    cmake_parse_arguments(test_param "" "" "LABELS" ${ARGN})

    add_executable(${test_name} ${test_name}.cpp)
    target_link_libraries(${test_name} osm2pgsql_lib catch_main_lib)
    add_test(NAME ${test_name} COMMAND ${test_name})

    set_tests_properties(${test_name} PROPERTIES TIMEOUT ${TESTING_TIMEOUT})

    if (DEFINED test_param_LABELS)
        list(FIND test_param_LABELS Tablespace test_num_labels)
        if (${test_num_labels} EQUAL -1)
            list(APPEND test_param_LABELS "NoTablespace")
        else()
            set_tests_properties(${test_name}
                                 PROPERTIES FIXTURES_REQUIRED Tablespace)
        endif()

        set_tests_properties(${test_name} PROPERTIES LABELS "${test_param_LABELS}")
    else()
        set_tests_properties(${test_name} PROPERTIES LABELS NoTablespace)
    endif()

    message(STATUS "Added test: ${test_name}...")
endfunction()

include_directories(SYSTEM "${CMAKE_CURRENT_SOURCE_DIR}/../contrib/catch2/include")

add_definitions(-DTESTDATA_DIR=\"${osm2pgsql_SOURCE_DIR}/tests/data/\")
add_definitions(-DOSM2PGSQLDATA_DIR=\"${osm2pgsql_SOURCE_DIR}/\")

add_library(catch_main_lib STATIC catch-main.cpp)

set_test(test-check-input LABELS NoDB)
set_test(test-db-copy-thread)
set_test(test-db-copy-mgr)
set_test(test-domain-matcher LABELS NoDB)
set_test(test-expire-from-geometry LABELS NoDB)
set_test(test-expire-tiles LABELS NoDB)
set_test(test-geom-box LABELS NoDB)
set_test(test-geom-collections LABELS NoDB)
set_test(test-geom-linestrings LABELS NoDB)
set_test(test-geom-multilinestrings LABELS NoDB)
set_test(test-geom-multipoints LABELS NoDB)
set_test(test-geom-multipolygons LABELS NoDB)
set_test(test-geom-null LABELS NoDB)
set_test(test-geom-output LABELS NoDB)
set_test(test-geom-points LABELS NoDB)
set_test(test-geom-polygons LABELS NoDB)
set_test(test-geom-pole-of-inaccessibility LABELS NoDB)
set_test(test-geom-transform LABELS NoDB)
set_test(test-json-writer LABELS NoDB)
set_test(test-middle)
set_test(test-node-locations LABELS NoDB)
set_test(test-options-database LABELS NoDB)
set_test(test-options-parse LABELS NoDB)
set_test(test-options-projection)
set_test(test-ordered-index LABELS NoDB)
set_test(test-output-gazetteer)
set_test(test-output-pgsql)
set_test(test-output-pgsql-area)
set_test(test-output-pgsql-hstore-match-only)
set_test(test-output-pgsql-int4)
set_test(test-output-pgsql-schema)
set_test(test-output-pgsql-style-file)
set_test(test-output-pgsql-tablespace LABELS Tablespace)
set_test(test-output-pgsql-validgeom)
set_test(test-output-pgsql-z_order)
set_test(test-parse-osmium LABELS NoDB)
set_test(test-persistent-cache LABELS NoDB)
set_test(test-pgsql)
set_test(test-pgsql-capabilities)
set_test(test-reprojection LABELS NoDB)
set_test(test-taginfo LABELS NoDB)
set_test(test-tile LABELS NoDB)
set_test(test-util LABELS NoDB)
set_test(test-wildcard-match LABELS NoDB)
set_test(test-wkb LABELS NoDB)

# these tests require LUA support
if (WITH_LUA)
    set_test(test-flex-indexes)
    set_test(test-lua-utils)
    set_test(test-output-flex)
    set_test(test-output-flex-multi-input)
    set_test(test-output-flex-nodes)
    set_test(test-output-flex-uni)
    set_test(test-output-flex-relations)
    set_test(test-output-flex-relation-combinations)
    set_test(test-output-flex-schema)
    set_test(test-output-flex-stage2)
    set_test(test-output-flex-tablespace LABELS Tablespace)
    set_test(test-output-flex-types)
    set_test(test-output-flex-update)
    set_test(test-output-flex-validgeom)

    set_test(test-output-flex-example-configs)
    set(FLEX_EXAMPLE_CONFIGS "addresses,attributes,bbox,compatible,data-types,generic,geometries,indexes,places,route-relations,simple,unitable")
    # with-schema.lua is not tested because it needs the schema created in the database
    set_tests_properties(test-output-flex-example-configs PROPERTIES ENVIRONMENT "EXAMPLE_FILES=${FLEX_EXAMPLE_CONFIGS}")
endif()


# Fixture for creating test tablespace under a pg_virtualenv
if (NOT WIN32)
    message(STATUS "Added tablespace fixture...")
    add_test(NAME FixtureTablespaceSetup
             COMMAND ${CMAKE_CURRENT_SOURCE_DIR}/fixture-tablespace-setup
             WORKING_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR})
    add_test(NAME FixtureTablespaceCleanup
             COMMAND ${CMAKE_CURRENT_SOURCE_DIR}/fixture-tablespace-cleanup
             WORKING_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR})

    set_tests_properties(FixtureTablespaceSetup PROPERTIES FIXTURES_SETUP Tablespace)
    set_tests_properties(FixtureTablespaceCleanup PROPERTIES FIXTURES_CLEANUP Tablespace)
endif()


find_program(BEHAVE_BIN NAMES behave)

if (BEHAVE_BIN)
    foreach(BDD_TEST IN ITEMS command-line flex regression)
        add_test(NAME bdd-${BDD_TEST}
                 COMMAND behave -DBINARY=$<TARGET_FILE:osm2pgsql> ${BDD_TEST}
                 WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}/bdd)
        message(STATUS "Added test: bdd-${BDD_TEST}")
    endforeach(BDD_TEST)

    set_tests_properties(bdd-regression
                         PROPERTIES FIXTURES_REQUIRED Tablespace)
else()
    message(WARNING "Cannot find behave, BDD tests disabled")
endif()

if (WITH_LUA)
    if (LUA_EXE)
        message(STATUS "Added test: lua-lib")
        add_test(NAME lua-lib COMMAND ${LUA_EXE} lua/tests.lua
                WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR})
        set_tests_properties(lua-lib PROPERTIES LABELS NoDB)
    else()
        message(WARNING "Can not find Lua interpreter, test 'lua-lib' disabled")
    endif()
endif()

=== debian/changelog ===
osm2pgsql (1.8.0+ds-1~bpo11+1) bullseye-backports; urgency=medium

  * Rebuild for bullseye-backports.
  * Skip dwz, causes FTBFS: Unknown DWARF DW_OP_255.

 -- Bas Couwenberg <sebastic@debian.org>  Fri, 03 Feb 2023 06:31:05 +0100

osm2pgsql (1.8.0+ds-1) unstable; urgency=medium

  * New upstream release.
  * Add Rules-Requires-Root to control file.
  * Bump Standards-Version to 4.6.2, no changes.
  * Update copyright file.
  * Drop obsolete rapidjson-dev build dependency.

 -- Bas Couwenberg <sebastic@debian.org>  Sat, 28 Jan 2023 18:59:54 +0100

osm2pgsql (1.7.2+ds-1~bpo11+1) bullseye-backports; urgency=medium

  * Rebuild for bullseye-backports.

 -- Bas Couwenberg <sebastic@debian.org>  Wed, 16 Nov 2022 05:47:42 +0100

osm2pgsql (1.7.2+ds-1) unstable; urgency=medium

  * New upstream release.
  * Drop osm2pgsql-replication-install.patch, fixed upstream.

 -- Bas Couwenberg <sebastic@debian.org>  Fri, 11 Nov 2022 06:58:38 +0100

osm2pgsql (1.7.1+ds-2~bpo11+1) bullseye-backports; urgency=medium

  * Rebuild for bullseye-backports.

 -- Bas Couwenberg <sebastic@debian.org>  Tue, 08 Nov 2022 05:19:21 +0100

osm2pgsql (1.7.1+ds-2) unstable; urgency=medium

  * Set OSM2PGSQL_BINDIR for osm2pgsql-replication.

 -- Bas Couwenberg <sebastic@debian.org>  Wed, 05 Oct 2022 06:40:46 +0200

osm2pgsql (1.7.1+ds-1) unstable; urgency=medium

  * New upstream release.
  * Add patch to fix osm2pgsql-replication installation.
  * Update lintian overrides.

 -- Bas Couwenberg <sebastic@debian.org>  Wed, 05 Oct 2022 05:21:03 +0200

osm2pgsql (1.7.0+ds-1~bpo11+1) bullseye-backports; urgency=medium

  * Rebuild for bullseye-backports.

 -- Bas Couwenberg <sebastic@debian.org>  Sun, 21 Aug 2022 06:47:46 +0200

osm2pgsql (1.6.0+ds-1~bpo11+1) bullseye-backports; urgency=medium

  * Rebuild for bullseye-backports.

 -- Bas Couwenberg <sebastic@debian.org>  Sun, 30 Jan 2022 06:55:24 +0100

osm2pgsql (1.5.2+ds-1~bpo11+1) bullseye-backports; urgency=medium

  * Rebuild for bullseye-backports.

 -- Bas Couwenberg <sebastic@debian.org>  Mon, 17 Jan 2022 05:52:21 +0100

osm2pgsql (1.5.1+ds-1~bpo11+1) bullseye-backports; urgency=medium

  * Rebuild for bullseye-backports.
  * Update branch in gbp.conf & Vcs-Git URL.

 -- Bas Couwenberg <sebastic@debian.org>  Fri, 20 Aug 2021 08:39:29 +0200

=== debian/control ===
Source: osm2pgsql
Maintainer: Debian GIS Project <pkg-grass-devel@lists.alioth.debian.org>
Uploaders: Francesco Paolo Lovergine <frankie@debian.org>,
           David Paleino <dapal@debian.org>,
           Andreas Tille <tille@debian.org>,
           Bas Couwenberg <sebastic@debian.org>
Section: utils
Priority: optional
Build-Depends: debhelper-compat (= 12),
               cmake,
               dh-python,
               libboost-dev,
               libboost-system-dev,
               libboost-filesystem-dev,
               libbz2-dev,
               libexpat1-dev,
               libosmium2-dev (>= 2.17.3),
               libpq-dev,
               libproj-dev,
               zlib1g-dev,
               liblua5.3-dev,
               lua5.3,
               python3,
               python3-argparse-manpage,
               python3-psycopg2,
               python3-pyosmium
Standards-Version: 4.6.2
Vcs-Browser: https://salsa.debian.org/debian-gis-team/osm2pgsql
Vcs-Git: https://salsa.debian.org/debian-gis-team/osm2pgsql.git -b bullseye-backports
Homepage: https://osm2pgsql.org/
Rules-Requires-Root: no

Package: osm2pgsql
Architecture: any
Depends: python3-psycopg2,
         python3-pyosmium,
         ${python3:Depends},
         ${shlibs:Depends},
         ${misc:Depends}
Recommends: postgis
Description: OpenStreetMap data to PostgreSQL converter
 Convert OSM planet snapshot data to SQL suitable for loading
 into a PostgreSQL database with PostGIS geospatial extensions. This
 database may then be used to render maps with Mapnik or for other
 geospatial analysis.

=== debian/rules ===
#!/usr/bin/make -f
# debian/rules for osm2pgsql

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

# Enable hardening build flags
export DEB_BUILD_MAINT_OPTIONS=hardening=+all

# Verbose test output
export VERBOSE=1

CFLAGS += $(CPPFLAGS) -DNDEBUG
CXXFLAGS += $(CPPFLAGS) -DNDEBUG

%:
	dh $@ --with python3 --buildsystem cmake

override_dh_auto_configure:
	dh_auto_configure -- -DEXTERNAL_LIBOSMIUM=ON \
	                     -DEXTERNAL_PROTOZERO=ON \
	                     -DEXTERNAL_RAPIDJSON=ON

override_dh_auto_test:
	dh_auto_test || echo "Ignoring test failures"

override_dh_compress:
	# clean up some naive file permissions
	dh_compress -X.php -X.sql -X.js -X.c -X.h

# Skip dwz, causes FTBFS: Unknown DWARF DW_OP_255
override_dh_dwz:

## osm2pgsql 1.9.0+ds

=== debian/changelog ===
osm2pgsql (1.9.0+ds-1) unstable; urgency=medium

  * New upstream release.
  * Drop gcc-13 patch, included upstream.
  * Update build dependencies for osm2pgsql-gen.

 -- Bas Couwenberg <sebastic@debian.org>  Wed, 16 Aug 2023 06:25:14 +0200

osm2pgsql (1.8.1+ds-2) unstable; urgency=medium

  * Bump debhelper compat to 13.
  * Add upstream patch to fix FTBFS with gcc-13.
    (closes: #1037812)
  * Use external {fmt}.
  * Update lintian overrides.

 -- Bas Couwenberg <sebastic@debian.org>  Thu, 13 Jul 2023 19:10:14 +0200

osm2pgsql (1.8.1+ds-1) unstable; urgency=medium

  * Move from experimental to unstable.

 -- Bas Couwenberg <sebastic@debian.org>  Sun, 11 Jun 2023 11:57:46 +0200

osm2pgsql (1.8.1+ds-1~exp1) experimental; urgency=medium

  * New upstream release.

 -- Bas Couwenberg <sebastic@debian.org>  Mon, 13 Feb 2023 14:40:29 +0100

=== debian/control ===
--- 
+++ 
@@ -6,7 +6,8 @@
            Bas Couwenberg <sebastic@debian.org>
 Section: utils
 Priority: optional
-Build-Depends: debhelper-compat (= 12),
+Build-Depends: debhelper-compat (= 13),
+               cimg-dev,
                cmake,
                dh-python,
                libboost-dev,
@@ -14,19 +15,22 @@
                libboost-filesystem-dev,
                libbz2-dev,
                libexpat1-dev,
+               libfmt-dev,
                libosmium2-dev (>= 2.17.3),
+               libpotrace-dev,
                libpq-dev,
                libproj-dev,
                zlib1g-dev,
                liblua5.3-dev,
                lua5.3,
+               nlohmann-json3-dev,
                python3,
                python3-argparse-manpage,
                python3-psycopg2,
                python3-pyosmium
 Standards-Version: 4.6.2
 Vcs-Browser: https://salsa.debian.org/debian-gis-team/osm2pgsql
-Vcs-Git: https://salsa.debian.org/debian-gis-team/osm2pgsql.git -b bullseye-backports
+Vcs-Git: https://salsa.debian.org/debian-gis-team/osm2pgsql.git
 Homepage: https://osm2pgsql.org/
 Rules-Requires-Root: no

## osm2pgsql 1.9.1+ds

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,7 +1,7 @@
 
-cmake_minimum_required(VERSION 3.5.0)
-
-project(osm2pgsql VERSION 1.8.0 LANGUAGES CXX C)
+cmake_minimum_required(VERSION 3.8.0)
+
+project(osm2pgsql VERSION 1.9.1 LANGUAGES CXX C)
 
 set(CMAKE_EXPORT_COMPILE_COMMANDS ON)
 
@@ -37,12 +37,8 @@
     set(CMAKE_BUILD_TYPE RelWithDebInfo)
 endif()
 
-if (NOT "${CMAKE_CXX_STANDARD}")
-    set(CMAKE_CXX_STANDARD 17)
-endif()
-message(STATUS "Building in C++${CMAKE_CXX_STANDARD} mode")
+# We don't want to use special compiler extensions because we want portability
 set(CMAKE_CXX_EXTENSIONS OFF)
-set(CMAKE_CXX_STANDARD_REQUIRED ON)
 
 if (MSVC)
     add_definitions(-D_CRT_SECURE_NO_WARNINGS -DNOMINMAX)
@@ -204,6 +200,14 @@
 include_directories(SYSTEM ${PostgreSQL_INCLUDE_DIRS})
 
 find_package(Threads)
+
+find_path(NLOHMANN_INCLUDE_DIR nlohmann/json.hpp)
+include_directories(SYSTEM ${NLOHMANN_INCLUDE_DIR})
+
+find_path(POTRACE_INCLUDE_DIR potracelib.h)
+find_library(POTRACE_LIBRARY NAMES potrace)
+
+find_path(CIMG_INCLUDE_DIR CImg.h)
 
 ############### Libraries are found now ########################
 
@@ -276,6 +280,33 @@
 add_executable(osm2pgsql src/osm2pgsql.cpp)
 target_link_libraries(osm2pgsql osm2pgsql_lib ${LIBS})
 
+if (${POTRACE_LIBRARY} STREQUAL "POTRACE_LIBRARY-NOTFOUND" OR ${CIMG_INCLUDE_DIR} STREQUAL "CIMG_INCLUDE_DIR-NOTFOUND")
+    message(STATUS "Did not find cimg and/or potrace library. Not building osm2pgsql-gen.")
+else()
+    if (WITH_LUA)
+        message(STATUS "Found cimg and potrace library. Building osm2pgsql-gen.")
+        set(BUILD_GEN 1)
+        include_directories(SYSTEM ${CIMG_INCLUDE_DIR})
+        include_directories(SYSTEM ${POTRACE_INCLUDE_DIR})
+        add_executable(osm2pgsql-gen src/gen/osm2pgsql-gen.cpp
+                    src/gen/canvas.cpp
+                    src/gen/gen-base.cpp
+                    src/gen/gen-create.cpp
+                    src/gen/gen-discrete-isolation.cpp
+                    src/gen/gen-rivers.cpp
+                    src/gen/gen-tile-builtup.cpp
+                    src/gen/gen-tile-raster.cpp
+                    src/gen/gen-tile-vector.cpp
+                    src/gen/gen-tile.cpp
+                    src/gen/params.cpp
+                    src/gen/raster.cpp
+                    src/gen/tracer.cpp)
+        target_link_libraries(osm2pgsql-gen osm2pgsql_lib ${LIBS} ${POTRACE_LIBRARY})
+    else()
+        message(STATUS "No Lua. Not building osm2pgsql-gen.")
+    endif()
+endif()
+
 #############################################################
 # Optional "clang-tidy" target
 #############################################################
@@ -287,7 +318,7 @@
 if (CLANG_TIDY)
     message(STATUS "Looking for clang-tidy - found ${CLANG_TIDY}")
 
-    file(GLOB CT_CHECK_FILES src/*.cpp tests/*cpp)
+    file(GLOB CT_CHECK_FILES src/*.cpp src/*/*.cpp tests/*cpp)
 
     add_custom_target(clang-tidy
         ${CLANG_TIDY}
@@ -311,26 +342,3 @@
     add_subdirectory(tests)
     configure_file(
         ${PROJECT_SOURCE_DIR}/tests/run-behave.in
-        ${PROJECT_BINARY_DIR}/run-behave
-    )
-else()
-    message(STATUS "Tests disabled. Set BUILD_TESTS=ON to enable tests.")
-endif()
-
-#############################################################
-# Man page
-#############################################################
-
-add_subdirectory(docs)
-
-#############################################################
-# Install
-#############################################################
-
-include(GNUInstallDirs)
-
-if (ENABLE_INSTALL)
-    install(TARGETS osm2pgsql DESTINATION bin)
-    install(FILES default.style empty.style DESTINATION share/osm2pgsql)
-    install(PROGRAMS scripts/osm2pgsql-replication DESTINATION bin)
-endif()

=== docs/CMakeLists.txt ===
--- 
+++ 
@@ -25,6 +25,17 @@
         VERBATIM)
 
     list(APPEND MANPAGE_TARGETS osm2pgsql.1)
+
+    if(BUILD_GEN)
+        add_custom_command(OUTPUT osm2pgsql-gen.1
+            COMMAND ${PANDOC} ${PANDOC_MAN_OPTIONS} -o osm2pgsql-gen.1
+                ${CMAKE_CURRENT_SOURCE_DIR}/osm2pgsql-gen.md
+            DEPENDS osm2pgsql-gen.md manpage.template
+            COMMENT "Building manpage osm2pgsql-gen.1"
+            VERBATIM)
+        list(APPEND MANPAGE_TARGETS osm2pgsql-gen.1)
+    endif()
+
 else()
     message(STATUS "Looking for pandoc - not found")
     message(STATUS "  osm2pgsql manual page can not be built")
@@ -53,4 +64,7 @@
 if(ENABLE_INSTALL)
     install(FILES osm2pgsql.1 DESTINATION share/man/man1)
     install(FILES osm2pgsql-replication.1 DESTINATION share/man/man1)
+    if (BUILD_GEN)
+        install(FILES osm2pgsql-gen.1 COMPONENT gen EXCLUDE_FROM_ALL DESTINATION share/man/man1)
+    endif()
 endif()

=== src/CMakeLists.txt ===
--- 
+++ 
@@ -1,10 +1,17 @@
 
 add_library(osm2pgsql_lib STATIC)
 
+# Set the minimum required C++ version for the library and hence for all
+# binaries that use it.
+target_compile_features(osm2pgsql_lib PUBLIC cxx_std_17)
+
 target_sources(osm2pgsql_lib PRIVATE
+  command-line-parser.cpp
   db-copy.cpp
+  debug-output.cpp
   dependency-manager.cpp
   expire-tiles.cpp
+  expire-output.cpp
   gazetteer-style.cpp
   geom.cpp
   geom-box.cpp
@@ -18,7 +25,6 @@
   middle-ram.cpp
   node-locations.cpp
   node-persistent-cache.cpp
-  options.cpp
   ordered-index.cpp
   osmdata.cpp
   output-gazetteer.cpp
@@ -29,6 +35,7 @@
   pgsql-capabilities.cpp
   pgsql-helper.cpp
   progress-display.cpp
+  properties.cpp
   reprojection.cpp
   table.cpp
   taginfo.cpp
@@ -50,10 +57,13 @@
         flex-index.cpp
         flex-table.cpp
         flex-table-column.cpp
+        flex-lua-expire-output.cpp
         flex-lua-geom.cpp
         flex-lua-index.cpp
+        flex-lua-table.cpp
         flex-write.cpp
         geom-transform.cpp
+        lua-setup.cpp
         lua-utils.cpp
         output-flex.cpp
         tagtransform-lua.cpp

=== tests/CMakeLists.txt ===
--- 
+++ 
@@ -36,6 +36,7 @@
 add_definitions(-DOSM2PGSQLDATA_DIR=\"${osm2pgsql_SOURCE_DIR}/\")
 
 add_library(catch_main_lib STATIC catch-main.cpp)
+target_compile_features(catch_main_lib PUBLIC cxx_std_17)
 
 set_test(test-check-input LABELS NoDB)
 set_test(test-db-copy-thread)
@@ -62,6 +63,7 @@
 set_test(test-options-parse LABELS NoDB)
 set_test(test-options-projection)
 set_test(test-ordered-index LABELS NoDB)
+set_test(test-osm-file-parsing LABELS NoDB)
 set_test(test-output-gazetteer)
 set_test(test-output-pgsql)
 set_test(test-output-pgsql-area)
@@ -72,10 +74,10 @@
 set_test(test-output-pgsql-tablespace LABELS Tablespace)
 set_test(test-output-pgsql-validgeom)
 set_test(test-output-pgsql-z_order)
-set_test(test-parse-osmium LABELS NoDB)
 set_test(test-persistent-cache LABELS NoDB)
 set_test(test-pgsql)
 set_test(test-pgsql-capabilities)
+set_test(test-properties)
 set_test(test-reprojection LABELS NoDB)
 set_test(test-taginfo LABELS NoDB)
 set_test(test-tile LABELS NoDB)
@@ -101,7 +103,7 @@
     set_test(test-output-flex-validgeom)
 
     set_test(test-output-flex-example-configs)
-    set(FLEX_EXAMPLE_CONFIGS "addresses,attributes,bbox,compatible,data-types,generic,geometries,indexes,places,route-relations,simple,unitable")
+    set(FLEX_EXAMPLE_CONFIGS "addresses,attributes,bbox,compatible,data-types,expire,generic,geometries,indexes,places,route-relations,simple,unitable")
     # with-schema.lua is not tested because it needs the schema created in the database
     set_tests_properties(test-output-flex-example-configs PROPERTIES ENVIRONMENT "EXAMPLE_FILES=${FLEX_EXAMPLE_CONFIGS}")
 endif()

=== debian/changelog ===
osm2pgsql (1.9.1+ds-1~bpo12+1) bookworm-backports; urgency=medium

  * Rebuild for bookworm-backports.

 -- Bas Couwenberg <sebastic@debian.org>  Mon, 28 Aug 2023 07:11:17 +0200

osm2pgsql (1.9.1+ds-1) unstable; urgency=medium

  * New upstream release.
  * Enable Salsa CI.

 -- Bas Couwenberg <sebastic@debian.org>  Wed, 23 Aug 2023 05:33:47 +0200

osm2pgsql (1.9.0+ds-1~bpo12+1) bookworm-backports; urgency=medium

  * Rebuild for bookworm-backports.

 -- Bas Couwenberg <sebastic@debian.org>  Mon, 21 Aug 2023 05:58:04 +0200

osm2pgsql (1.8.1+ds-2~bpo12+1) bookworm-backports; urgency=medium

  * Rebuild for bookworm-backports.
  * Update branch in gbp.conf & Vcs-Git URL.

 -- Bas Couwenberg <sebastic@debian.org>  Sun, 23 Jul 2023 15:00:30 +0200

=== debian/control ===
--- 
+++ 
@@ -30,7 +30,7 @@
                python3-pyosmium
 Standards-Version: 4.6.2
 Vcs-Browser: https://salsa.debian.org/debian-gis-team/osm2pgsql
-Vcs-Git: https://salsa.debian.org/debian-gis-team/osm2pgsql.git
+Vcs-Git: https://salsa.debian.org/debian-gis-team/osm2pgsql.git -b bookworm-backports
 Homepage: https://osm2pgsql.org/
 Rules-Requires-Root: no

=== debian/rules ===
--- 
+++ 
@@ -19,7 +19,7 @@
 override_dh_auto_configure:
 	dh_auto_configure -- -DEXTERNAL_LIBOSMIUM=ON \
 	                     -DEXTERNAL_PROTOZERO=ON \
-	                     -DEXTERNAL_RAPIDJSON=ON
+	                     -DEXTERNAL_FMT=ON
 
 override_dh_auto_test:
 	dh_auto_test || echo "Ignoring test failures"
@@ -27,6 +27,3 @@
 override_dh_compress:
 	# clean up some naive file permissions
 	dh_compress -X.php -X.sql -X.js -X.c -X.h
-
-# Skip dwz, causes FTBFS: Unknown DWARF DW_OP_255
-override_dh_dwz:

## osm2pgsql 1.10.0+ds

=== debian/changelog ===
osm2pgsql (1.10.0+ds-1) unstable; urgency=medium

  * New upstream release.
  * Add architecture-is-64-bit to build depends.
  * Remove cimg-dev from build dependencies and add libopencv-dev.
  * Update docs paths.

 -- Bas Couwenberg <sebastic@debian.org>  Tue, 07 Nov 2023 20:45:08 +0100

osm2pgsql (1.9.2+ds-1) unstable; urgency=medium

  * New upstream release.
  * Switch to dh-sequence-*.

 -- Bas Couwenberg <sebastic@debian.org>  Mon, 04 Sep 2023 15:07:51 +0200

=== debian/control ===
--- 
+++ 
@@ -6,16 +6,18 @@
            Bas Couwenberg <sebastic@debian.org>
 Section: utils
 Priority: optional
-Build-Depends: debhelper-compat (= 13),
-               cimg-dev,
+Build-Depends: architecture-is-64-bit,
+               debhelper-compat (= 13),
                cmake,
                dh-python,
+               dh-sequence-python3,
                libboost-dev,
                libboost-system-dev,
                libboost-filesystem-dev,
                libbz2-dev,
                libexpat1-dev,
                libfmt-dev,
+               libopencv-dev,
                libosmium2-dev (>= 2.17.3),
                libpotrace-dev,
                libpq-dev,
@@ -30,7 +32,7 @@
                python3-pyosmium
 Standards-Version: 4.6.2
 Vcs-Browser: https://salsa.debian.org/debian-gis-team/osm2pgsql
-Vcs-Git: https://salsa.debian.org/debian-gis-team/osm2pgsql.git -b bookworm-backports
+Vcs-Git: https://salsa.debian.org/debian-gis-team/osm2pgsql.git
 Homepage: https://osm2pgsql.org/
 Rules-Requires-Root: no

=== debian/rules ===
--- 
+++ 
@@ -14,7 +14,7 @@
 CXXFLAGS += $(CPPFLAGS) -DNDEBUG
 
 %:
-	dh $@ --with python3 --buildsystem cmake
+	dh $@ --buildsystem cmake
 
 override_dh_auto_configure:
 	dh_auto_configure -- -DEXTERNAL_LIBOSMIUM=ON \

## osm2pgsql 1.11.0+ds

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,7 +1,7 @@
 
 cmake_minimum_required(VERSION 3.8.0)
 
-project(osm2pgsql VERSION 1.9.1 LANGUAGES CXX C)
+project(osm2pgsql VERSION 1.11.0 LANGUAGES CXX C)
 
 set(CMAKE_EXPORT_COMPILE_COMMANDS ON)
 
@@ -16,6 +16,10 @@
     set(ENABLE_INSTALL OFF)
 endif()
 
+if (NOT ${CMAKE_SIZEOF_VOID_P} EQUAL 8)
+    message(FATAL_ERROR "osm2pgsql needs a 64 bit architecture")
+endif()
+
 if (WIN32)
     set(DEFAULT_STYLE "default.style" CACHE STRING "Default style used unless one is given on the command line")
 else()
@@ -51,6 +55,7 @@
 option(EXTERNAL_LIBOSMIUM "Do not use the bundled libosmium" OFF)
 option(EXTERNAL_PROTOZERO "Do not use the bundled protozero" OFF)
 option(EXTERNAL_FMT       "Do not use the bundled fmt"       OFF)
+option(EXTERNAL_CLI11     "Do not use the bundled CLI11"     OFF)
 
 set(USE_PROJ_LIB "auto" CACHE STRING "Which version of PROJ API to use: ('4', '6', 'off', or 'auto')")
 
@@ -171,10 +176,14 @@
     set(FMT_INCLUDE_DIR "${CMAKE_CURRENT_SOURCE_DIR}/contrib/fmt/include")
 endif()
 
+if (NOT EXTERNAL_CLI11)
+    set(CLI11_INCLUDE_DIR "${CMAKE_CURRENT_SOURCE_DIR}/contrib/CLI11/include")
+endif()
+
 include_directories(${CMAKE_CURRENT_SOURCE_DIR}/src ${CMAKE_CURRENT_BINARY_DIR})
 
 find_package(Osmium 2.17.3 REQUIRED COMPONENTS io)
-include_directories(SYSTEM ${OSMIUM_INCLUDE_DIRS} ${PROTOZERO_INCLUDE_DIR} ${FMT_INCLUDE_DIR})
+include_directories(SYSTEM ${OSMIUM_INCLUDE_DIRS} ${PROTOZERO_INCLUDE_DIR} ${FMT_INCLUDE_DIR} ${CLI11_INCLUDE_DIR})
 
 if (WITH_LUA)
     if (WITH_LUAJIT)
@@ -207,7 +216,7 @@
 find_path(POTRACE_INCLUDE_DIR potracelib.h)
 find_library(POTRACE_LIBRARY NAMES potrace)
 
-find_path(CIMG_INCLUDE_DIR CImg.h)
+find_package(OpenCV QUIET OPTIONAL_COMPONENTS core imgcodecs imgproc)
 
 ############### Libraries are found now ########################
 
@@ -257,16 +266,6 @@
 
 if (WIN32)
     list(APPEND LIBS ws2_32)
-    if (MSVC)
-        find_path(GETOPT_INCLUDE_DIR getopt.h)
-        find_library(GETOPT_LIBRARY NAMES wingetopt getopt)
-        if (GETOPT_INCLUDE_DIR AND GETOPT_LIBRARY)
-            include_directories(SYSTEM ${GETOPT_INCLUDE_DIR})
-            list(APPEND LIBS ${GETOPT_LIBRARY})
-        else()
-            message(FATAL_ERROR "Can not find getopt library for Windows. Please get it from https://github.com/alex85k/wingetopt or alternative source.")
-        endif()
-    endif()
 endif()
 
 message(STATUS "Libraries used to build: ${LIBS}")
@@ -280,13 +279,12 @@
 add_executable(osm2pgsql src/osm2pgsql.cpp)
 target_link_libraries(osm2pgsql osm2pgsql_lib ${LIBS})
 
-if (${POTRACE_LIBRARY} STREQUAL "POTRACE_LIBRARY-NOTFOUND" OR ${CIMG_INCLUDE_DIR} STREQUAL "CIMG_INCLUDE_DIR-NOTFOUND")
-    message(STATUS "Did not find cimg and/or potrace library. Not building osm2pgsql-gen.")
+if (${POTRACE_LIBRARY} STREQUAL "POTRACE_LIBRARY-NOTFOUND" OR NOT OPENCV_CORE_FOUND)
+    message(STATUS "Did not find opencv and/or potrace library. Not building osm2pgsql-gen.")
 else()
     if (WITH_LUA)
-        message(STATUS "Found cimg and potrace library. Building osm2pgsql-gen.")
+        message(STATUS "Found opencv and potrace library. Building osm2pgsql-gen.")
         set(BUILD_GEN 1)
-        include_directories(SYSTEM ${CIMG_INCLUDE_DIR})
         include_directories(SYSTEM ${POTRACE_INCLUDE_DIR})
         add_executable(osm2pgsql-gen src/gen/osm2pgsql-gen.cpp
                     src/gen/canvas.cpp
@@ -301,7 +299,7 @@
                     src/gen/params.cpp
                     src/gen/raster.cpp
                     src/gen/tracer.cpp)
-        target_link_libraries(osm2pgsql-gen osm2pgsql_lib ${LIBS} ${POTRACE_LIBRARY})
+        target_link_libraries(osm2pgsql-gen osm2pgsql_lib ${LIBS} ${POTRACE_LIBRARY} ${OpenCV_LIBS})
     else()
         message(STATUS "No Lua. Not building osm2pgsql-gen.")
     endif()
@@ -342,3 +340,11 @@
     add_subdirectory(tests)
     configure_file(
         ${PROJECT_SOURCE_DIR}/tests/run-behave.in
+        ${PROJECT_BINARY_DIR}/run-behave
+    )
+else()
+    message(STATUS "Tests disabled. Set BUILD_TESTS=ON to enable tests.")
+endif()
+
+#############################################################
+# Man page

=== src/CMakeLists.txt ===
--- 
+++ 
@@ -6,6 +6,7 @@
 target_compile_features(osm2pgsql_lib PUBLIC cxx_std_17)
 
 target_sources(osm2pgsql_lib PRIVATE
+  command-line-app.cpp
   command-line-parser.cpp
   db-copy.cpp
   debug-output.cpp

=== tests/CMakeLists.txt ===
--- 
+++ 
@@ -59,7 +59,6 @@
 set_test(test-json-writer LABELS NoDB)
 set_test(test-middle)
 set_test(test-node-locations LABELS NoDB)
-set_test(test-options-database LABELS NoDB)
 set_test(test-options-parse LABELS NoDB)
 set_test(test-options-projection)
 set_test(test-ordered-index LABELS NoDB)

=== debian/changelog ===
osm2pgsql (1.11.0+ds-1) unstable; urgency=medium

  * New upstream release.
  * Update copyright file.
  * Use external CLI11.

 -- Bas Couwenberg <sebastic@debian.org>  Tue, 13 Feb 2024 05:41:02 +0100

=== debian/control ===
--- 
+++ 
@@ -15,6 +15,7 @@
                libboost-system-dev,
                libboost-filesystem-dev,
                libbz2-dev,
+               libcli11-dev,
                libexpat1-dev,
                libfmt-dev,
                libopencv-dev,

=== debian/rules ===
--- 
+++ 
@@ -19,7 +19,8 @@
 override_dh_auto_configure:
 	dh_auto_configure -- -DEXTERNAL_LIBOSMIUM=ON \
 	                     -DEXTERNAL_PROTOZERO=ON \
-	                     -DEXTERNAL_FMT=ON
+	                     -DEXTERNAL_FMT=ON \
+	                     -DEXTERNAL_CLI11=ON
 
 override_dh_auto_test:
 	dh_auto_test || echo "Ignoring test failures"

## osm2pgsql 2.0.0+ds

=== debian/changelog ===
osm2pgsql (2.0.0+ds-1) unstable; urgency=medium

  * New upstream release.
  * Bump Standards-Version to 4.7.0, no changes.
  * Drop obsolete Boost build dependencies.
  * Don't use external libfmt, causes FTBFS.

 -- Bas Couwenberg <sebastic@debian.org>  Thu, 19 Sep 2024 18:32:12 +0200
